var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { Component, Input } from '@angular/core';
import { NavigationStart, NavigationEnd, NavigationCancel } from '@angular/router';
import { defaultPageTransition } from './default-transition.animation';
var Ng2PageTransitionComponent = (function () {
    function Ng2PageTransitionComponent(router) {
        var _this = this;
        this.router = router;
        this.scrollTop = true;
        this.onlyOnRoutes = [""];
        this.animation = {
            state: "leave",
            custom: false,
            enterDelay: 0
        };
        this.animation.state = "leave";
        router.events.subscribe(function (event) {
            for (var i = 0; i < _this.onlyOnRoutes.length; i++) {
                if (event.url && event.url.indexOf(_this.onlyOnRoutes[i]) > -1) {
                    if (event instanceof NavigationStart) {
                        _this.animation.state = "leave";
                        _this.delayPromise = new Promise(function (resolve, reject) {
                            window.setTimeout(function () {
                                resolve(true);
                            }, _this.animation.enterDelay);
                        });
                    }
                    else if (event instanceof NavigationEnd || event instanceof NavigationCancel) {
                        if (typeof _this.delayPromise !== "undefined") {
                            _this.delayPromise.then(function () {
                                _this.animation.state = "out";
                                if (_this.scrollTop) {
                                    window.scrollTo(0, 0);
                                }
                                setTimeout(function () {
                                    _this.animation.state = "enter";
                                }, 0);
                            });
                        }
                        else {
                            _this.animation.state = "out";
                            if (_this.scrollTop) {
                                window.scrollTo(0, 0);
                            }
                            setTimeout(function () {
                                _this.animation.state = "enter";
                            }, 0);
                        }
                    }
                    return;
                }
            }
        });
    }
    return Ng2PageTransitionComponent;
}());
__decorate([
    Input()
], Ng2PageTransitionComponent.prototype, "scrollTop", void 0);
__decorate([
    Input()
], Ng2PageTransitionComponent.prototype, "onlyOnRoutes", void 0);
__decorate([
    Input()
], Ng2PageTransitionComponent.prototype, "animation", void 0);
Ng2PageTransitionComponent = __decorate([
    Component({
        selector: 'ng2-page-transition',
        template: '<div [@ng2ElementState]="animation.custom || animation.state"><ng-content></ng-content></div>',
        animations: [defaultPageTransition()],
    })
], Ng2PageTransitionComponent);
export { Ng2PageTransitionComponent };
//# sourceMappingURL=ng2-page-transition.component.js.map